function snr = calcsnr(x,xref)
% snr = calcsnr(x,xref)
%
% INPUT:
% x: estimated image
% xref: reference image
%
% OUTPUT:
% snr: vector containing the snr snr(1) and psnr snr(2)
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                 *
%* date: Friday, July, 24th 2009                     *
%*****************************************************


MSE = mean((xref(:)-x(:)).^2);
snr(1) = 10*log10(mean(xref(:).^2)/MSE);
snr(2) = 10*log10(255^2/MSE);