function [a,beta,fstein,v,vq,ETp] = decwavrsureletbt(wrc,jm,qmf,sigmab,Gam,Vwb,Gamt,Kappa,alpha,indp,rt,Gb)
%[a,beta,fstein,v,vq,ETp] = decwavrsureletbt(wrc,jm,qmf,sigmab,Gam,Vwb,Gamt,Kappa,chi,indp,rt,Gb)
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                      *
%* date: Friday, July, 24th 2009                     *
%*****************************************************


[N,M] = size(rt);

if nargin == 12
    Gb = ones(N,M);
end
Gb(indp) = 0;

mim = 6*jm+1;
beta = zeros(mim,N,M);
f = zeros(mim,1);
v = zeros(mim,1);
vq = zeros(mim,mim);
ETp = zeros(3*jm+1,3);

wrct = zeros(N*(3*jm+1),M);

J = log2(N);

mi = 1;
fprintf(1,'m = ');
for mib = 1:3*jm+1
    fprintf(1,'%d ',mib);
    wrct((mib-1)*N+1:mib*N,:) = wrc((mib-1)*N+1:mib*N,:);
    betat = IWT2_TI(wrct,J-jm,qmf);
    betat = real(ifft2(Gb.*fft2(betat)));
    if mib ~= 3*jm+1
        beta(mi+1,:,:) = betat;
        f(mi+1) = -sigmab^2*Gam(mib)*N*M;
        v(mi+1) = Kappa(mib)*N*M;
        vq(mi+1,mi+1) = Gamt(mib)*N*M;
        ETp(mib+1,1) = 1;
        mi = mi+1;
        sigmawb = sigmab*sqrt(Vwb(mib));
        betat = IWT2_TI(fblu(wrct,alpha*sigmawb),J-jm,qmf);
        betat = real(ifft2(Gb.*fft2(betat)));
        beta(mi+1,:,:) = betat;
        swrc = sum(sum(dfblu(wrc((mib-1)*N+1:mib*N,:),alpha*sigmawb)));
        ETp(mib+1,2) = swrc/N/M;
        swrc2 = sum(sum(dfblu(wrc((mib-1)*N+1:mib*N,:),alpha*sigmawb).^2));
        ETp(mib+1,3) = (swrc2/N/M-swrc^2/(N*M)^2)*Gam(mib)^2*N*M;
        f(mi+1) = -sigmab^2*Gam(mib)*swrc;
        v(mi+1) = Kappa(mib)*swrc;
        vq(mi+1,mi+1) = Gam(mib)^2*(swrc2-swrc^2/N/M)+Gamt(mib)*swrc^2/N/M;
        vq(mi+1,mi) = Gamt(mib)*swrc;
        vq(mi,mi+1) = vq(mi+1,mi);
        mi = mi+1;
        wrct((mib-1)*N+1:mib*N,:) = zeros(N,M);
    else
        beta(1,:,:) = betat;
        f(1) = -sigmab^2*Gam(mib)*N*M;
        v(1) = Kappa(mib)*N*M;
        vq(1,1) = Gamt(mib)*N*M;
        ETp(1,1) = 1;
    end
end
fprintf(1,'\n');

fstein = -2*f;

betaM = zeros(mim,mim);
for mi = 1:mim
    f(mi) = f(mi)+sum(sum(squeeze(beta(mi,:,:)).*rt));
    for mi2 = mi:mim
        betaM(mi,mi2) = sum(sum(beta(mi,:,:).*beta(mi2,:,:)));
        
        if mi2 ~= mi
            betaM(mi2,mi) = betaM(mi,mi2);
        end
    end
end

a = pinv(betaM)*f;