function [a,beta,fstein,v,vq,ETp] = decwavt2sureletbt(wrc,jm,sw,wavname,dec,sigmab,Gam,Vwb,Gamt,Kappa,alpha,indp,rt,Gb)
% [a,beta,fstein,v,vq,ETp] = decwavt2sureletbt(wrc,jm,sw,wavname,dec,sigmab,Gam,Vwb,Gamt,Kappa,alpha,indp,rt,Gb)
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                      *
%* date: Friday, July, 24th 2009                     *
%*****************************************************

N = sw(end,1);
M = sw(end,2);

nu = size(dec,1);

if nargin == 13
    Gb = ones(N,M);
end
Gb(indp) = 0;

mim = 6*jm+1;
beta = zeros(mim,N,M);
f = zeros(mim,1);
v = zeros(mim,1);
vq = zeros(mim,mim);
ETp = zeros(3*jm+1,3);

Nr = N*M/2^(2*jm);
iw0 = Nr;
ind = 1:iw0;
wrct = zeros(nu,N*M);
wrct(:,ind) = wrc(:,ind);
betat = waverec2d(wrct,sw,wavname,dec);
betat = real(ifft2(Gb.*fft2(betat)));
beta(1,:,:) = betat;
f(1) = -sigmab^2*Gam(1)*Nr*nu;
v(1) = Kappa(1)*Nr*nu;
vq(1,1) = Gamt(1)*Nr;
ETp(1,1) = 1;
ETp(1,2) = 0;
ETp(1,3) = 0;
mi = 2;
mib = 2;
fprintf(1,'j = ');
for j = 1:jm
    fprintf(1,'%d    ',j);
    for d = 1:3 % d =1 : H, 2 : V, 3 : D
        ind = iw0+Nr*(d-1)+1:iw0+Nr*d;
        wrct = zeros(nu,N*M);
        wrct(:,ind) = wrc(:,ind);
        betat = waverec2d(wrct,sw,wavname,dec);
        betat = real(ifft2(Gb.*fft2(betat)));
        beta(mi,:,:) = betat;
        f(mi) = -sigmab^2*Gam(mib)*Nr*nu;
        v(mi) = Kappa(mib)*Nr*nu;
        vq(mi,mi) = Gamt(mib)*Nr;
        ETp(mib,1) = 1;
        mi = mi+1;
        sigmawb = sigmab*sqrt(Vwb(mib));
        betat = waverec2d(fblu(wrct,alpha*sigmawb),sw,wavname,dec);
        betat = real(ifft2(Gb.*fft2(betat)));
        beta(mi,:,:) = betat;
        swrc = sum(sum(dfblu(wrct(:,ind),alpha*sigmawb)));
        ETp(mib,2) = swrc/Nr/nu;
        swrc2 = sum(sum(dfblu(wrct(:,ind),alpha*sigmawb).^2));
        ETp(mib,3) = (swrc2/Nr/nu-swrc^2/(Nr*nu)^2)*Gam(mib)^2*Nr/nu;
        f(mi) = -sigmab^2*Gam(mib)*swrc;
        v(mi) = Kappa(mib)*swrc;
        vq(mi,mi) = Gam(mib)^2/nu^2*(swrc2-swrc^2/Nr/nu)+ Gamt((mi+1)/2)*swrc^2/Nr/nu^2;
        vq(mi,mi-1) = Gamt(mib)*swrc/nu;
        vq(mi-1,mi) = vq(mi,mi-1);
        mi = mi+1;
        mib = mib+1;
    end
    iw0 = ind(end);
    Nr = Nr*4;
end
fprintf(1,'\n');
beta = beta/nu;
f = f/nu;
v = v/nu;

fstein = -2*f;

betaM = zeros(mim,mim);
for mi = 1:mim
    f(mi) = f(mi)+sum(sum(squeeze(beta(mi,:,:)).*rt));
    for mi2 = mi:mim
        betaM(mi,mi2) = sum(sum(beta(mi,:,:).*beta(mi2,:,:)));
        
        if mi2 ~= mi
            betaM(mi2,mi) = betaM(mi,mi2);
        end
    end
end

a = pinv(betaM)*f;