function y = fblu(x,alpha)
% function y = fblu(x,alpha)
% 
% INPUT:
% x: data
% alpha: parameter necessary to compute the exponential function considered
% in (Eq. 17)
% T. Blu, F. Luisier, "The SURE-LET Approach to Image Denoising," 
% IEEE Transactions on Image Processing, vol. 16, no. 11, pp. 2778-2786, 
% November 2007. 
%
% OUTPUT:
% y = (1-exp(-(x/alpha).^8)).*x;
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                      *
%* date: Friday, July, 24th 2009                     *
%*****************************************************

y = (1-exp(-(x/alpha).^8)).*x;