function g=gaussian_kernel(k,sigma)
%
%g=gaussian_kernel(k,sigma)
%
% Compute a gaussian kernel
% k: radius --> blur kernel of size 2*k+1
% sigma: standard deviation
%
%*****************************************************
%* author: Jean-Christophe PESQUET                   *
%* institution: LIGM - UMR CNRS 8049         	     *
%*	       Université Paris-Est                      *
%* date: Friday, July, 24th 2009                     *
%*****************************************************

i=1;
j=1;
g=zeros(2*k+1);

x = (-k:k)'*ones(1,2*k+1);
y = x';

g = exp(-(x.^2+y.^2)/(2*sigma^2));

g=g/(sum(g(:)));